/***************************************************************************
 *
 * ev_cntnr.cc - template definitions for RW_VBase<StdColl,RWColl>
 * 
 * $Id: ev_cntnr.cc,v 7.8 1996/02/18 01:41:13 griswolf Exp $
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 ****************************************************************************
 * 
 * $Log: ev_cntnr.cc,v $
 * Revision 7.8  1996/02/18 01:41:13  griswolf
 * Replace tabs with spaces, per Rogue Wave standard.
 *
 * Revision 7.7  1995/12/11 22:30:41  jims
 * Remove 'Sca' from interior class names
 * Add 'rw_' to global helper classes
 * Change 'muterator' to 'filterator'
 *
 * Revision 7.6  1995/10/27 16:07:46  jims
 * Qualify size_type in definition of npos
 *
 * Revision 7.5  1995/09/05  21:59:14  jims
 * Change tlyrs.h to tlyrs.str
 *
 * Revision 7.4  1995/07/27  22:02:33  jims
 * Add header with file name, short description, $Id and $Log
 * 
 ****************************************************************************/

#define TEMPLATE template <class StdColl, class RWColl>
#define VC       RW_VBase<StdColl, RWColl>

TEMPLATE
void VC::apply(
/*constApplyFunction*/  void (*fn)(VC::const_reference,void*),
                        void* x
                       ) const
{
  for(const_iterator i= begin(); i != end(); ++i) {
    (*fn)(*i,x);
  }
}

TEMPLATE
void VC::apply(
/*mutativeApplyFunction*/  void (*fn)(VC::reference,void*),
                        void* x
                       ) 
{
  for(iterator i= begin(); i != end(); ++i) {
    (*fn)(*i,x);
  }
}

TEMPLATE
bool VC::contains(
/*testFunction*/     bool (*fn)(VC::const_reference,void*),
                     void* x
                    ) const
{
  const_iterator i = begin();
  for(/**/ ; i != end(); ++i)
    if((*fn)(*i,x))
      break;
  return i != end();
}

TEMPLATE
bool VC::contains(const_reference key) const
{
  const_iterator i = begin();
  for(/**/ ; i != end(); ++i)
    if(*i == key)
      break;
  return i != end();
}


TEMPLATE
VC::size_type
VC::occurrencesOf(
                  bool (*fn)(VC::const_reference,void*),
                  void* x
                 ) const
{
  size_type ret(0);
  const_iterator i = begin();
  for(/**/; i != end(); ++i)
    if((*fn)(*i,x))
      ++ret;
  return ret;
}

TEMPLATE
VC::size_type
VC::occurrencesOf(const_reference key) const
{
  size_type ret(0);
  const_iterator i = begin();
  for(/**/; i != end(); ++i)
    if(*i == key)
      ++ret;
  return ret;
}

TEMPLATE
VC::size_type
VC::index(bool (*fn)(VC::const_reference, void*), void* x) const
{
  const_iterator i = begin();
  size_type idx(0);
  for(/**/; i != end(); ++i) {
    if((*fn)(*i,x))
      return idx;
    ++idx;
  }
  return npos;
}

TEMPLATE
VC::size_type
VC::index(const_reference key) const
{
  size_type ret = 0;
  const_iterator i;
  for(i = begin(); i != end(); ++i)
  {
    if(*i == key) break;
    ++ret;
  }
  return i == this->end() ? npos : ret;
}

TEMPLATE
VC::size_type VC::npos = ~(VC::size_type)0;

#undef TEMPLATE
#undef VC
